Index: org/postgresql/jdbc1/DatabaseMetaData.java
===================================================================
RCS file: /cvs/pgjdbc71/org/postgresql/jdbc1/DatabaseMetaData.java,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 DatabaseMetaData.java
--- org/postgresql/jdbc1/DatabaseMetaData.java	2001/10/04 05:01:32	1.1.1.1
+++ org/postgresql/jdbc1/DatabaseMetaData.java	2001/10/25 01:04:58
@@ -1932,7 +1932,19 @@
 	
 	tuple[7] = null;	// Buffer length
 	
-	tuple[8] = "0".getBytes();	// Decimal Digits - how to get this?
+        // Decimal digits = scale
+        // From the source (see e.g. backend/utils/adt/numeric.c, 
+        // function numeric()) the scale and precision can be calculated
+        // from the typmod value. mark-jdbc@inomial.com
+        if (typname.equals("numeric") || typname.equals("decimal")) 
+        { 
+          int attypmod = r.getInt(8);
+          tuple[8] =
+            Integer.toString((attypmod & 0xffff) - VARHDRSZ).getBytes();
+        }
+        else
+          tuple[8] = "0".getBytes();
+
 	tuple[9] = "10".getBytes();	// Num Prec Radix - assume decimal
 	
 	// tuple[10] is below
